package gui.run;

import java.util.Observable;

public class ObservableString extends Observable {

    private String value = "";

    public synchronized void setValue(String newValue) {
        if (newValue != value) {
            value = newValue;
            super.setChanged();
            super.notifyObservers(this);
        }
    }

    public synchronized String getValue() {
        return value;
    }
}